import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson2.JSONObject;
import com.baomidou.dynamic.datasource.toolkit.DynamicDataSourceContextHolder;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.admin.BytesailingApplication;
import com.fjhx.common.constant.SourceConstant;
import com.fjhx.victoriatourist.service.jd.JdOrderService;
import com.fjhx.victoriatourist.service.jd.constants.RunParamConstant;
import com.fjhx.victoriatourist.service.jd.impl.JdApiServiceImpl;
import com.fjhx.wms.entity.stock.dto.StockWaitSelectDto;
import com.fjhx.wms.entity.stock.vo.StockWaitVo;
import com.fjhx.wms.service.stock.impl.StockWaitServiceImpl;
import com.jd.open.api.sdk.JdClient;
import com.jd.open.api.sdk.domain.supplier.SparePartInventoryJosService.response.list.JosResult;
import com.jd.open.api.sdk.request.supplier.EdiwsRoRefundInfoListRequest;
import com.jd.open.api.sdk.response.supplier.EdiwsRoRefundInfoListResponse;
import com.ruoyi.common.annotation.TenantIgnore;
import com.ruoyi.common.utils.SecurityUtils;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;


@RunWith(SpringRunner.class)
@SpringBootTest(classes = BytesailingApplication.class, webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
@Slf4j
public class BootTest {

    @Autowired
    private JdApiServiceImpl jdApiServiceImpl;


    @Autowired
    private StockWaitServiceImpl stockWaitServiceImpl;

    @Autowired
    private JdOrderService jdOrderService;

    @Autowired
    private JdClient jdClient;

    /**
     * 重新同步 同步异常的京东采购单
     */
    @TenantIgnore
    @Test
    public void test1() throws Exception {
        SecurityUtils.setTenantId(RunParamConstant.tenantId);
        DynamicDataSourceContextHolder.push(SourceConstant.VICTORIATOURIST);

        //jdApiServiceImpl.startJdOrder(null,null, Collections.singletonList(78L));


        EdiwsRoRefundInfoListRequest request = new EdiwsRoRefundInfoListRequest();
        request.setPageIndex(1);
        request.setPageSize(10);
        request.setApplyBeginTime(DateUtil.parseDateTime("2024-09-01 00:00:00"));
        request.setApplyEndTime(DateUtil.parseDateTime("2024-10-12 00:00:00"));
        request.setRefundId(73304331L);
        //request.setOutNo(73304331L);
        request.setVendorCode(RunParamConstant.VENDOR_CODE);
        EdiwsRoRefundInfoListResponse response = jdClient.execute(request);
        JosResult result = response.getResult();


        SecurityUtils.clearTenantId();
        DynamicDataSourceContextHolder.poll();
    }


    @TenantIgnore
    @Test
    public void test2() {
        SecurityUtils.setTenantId(RunParamConstant.tenantId);

        StockWaitSelectDto dto = new StockWaitSelectDto();
        dto.setKeyword("4004805206681078811");
        dto.setStatus(3);
        dto.setType("1");
        Page<StockWaitVo> pageByWdly = stockWaitServiceImpl.getPageByWdly(dto);
    }

}
