package com.fjhx.victoriatourist.controller.jd;

import com.baomidou.dynamic.datasource.toolkit.DynamicDataSourceContextHolder;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.common.constant.SourceConstant;
import com.fjhx.victoriatourist.entity.jd.dto.JdRefundQualityCheckDto;
import com.fjhx.victoriatourist.entity.jd.dto.JdRefundQualityCheckSelectDto;
import com.fjhx.victoriatourist.entity.jd.vo.JdRefundQualityCheckVo;
import com.fjhx.victoriatourist.service.jd.JdRefundQualityCheckService;
import com.ruoyi.common.core.domain.entity.SysDept;
import com.ruoyi.system.service.ISysDeptService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.stream.Collectors;


/**
 * <p>
 * 京东售后退货质检 前端控制器
 * </p>
 *
 * @author
 * @since 2024-09-27
 */
@Slf4j
@RestController
@RequestMapping("/jdRefundQualityCheck")
public class JdRefundQualityCheckController {

    @Autowired
    private JdRefundQualityCheckService jdRefundQualityCheckService;

    @Autowired
    private ISysDeptService sysDeptService;

    /**
     * 京东售后退货质检分页
     */
    @GetMapping("/getPage")
    public Page<JdRefundQualityCheckVo> page(JdRefundQualityCheckSelectDto dto) {
        return jdRefundQualityCheckService.getPage(dto);
    }

    /**
     * 导出
     */
    @PostMapping("/exportExcel")
    public void exportExcel(@RequestBody JdRefundQualityCheckSelectDto dto) {
        jdRefundQualityCheckService.exportExcel(dto);
    }

    /**
     * 处理
     */
    @PostMapping("/handle")
    public void handle(@RequestBody JdRefundQualityCheckDto dto) {
        jdRefundQualityCheckService.handle(dto);
    }

    /**
     * 批量处理
     */
    @PostMapping("/batchHandle")
    public void batchHandle(@RequestBody List<JdRefundQualityCheckDto> dto) {
        jdRefundQualityCheckService.batchHandle(dto);
    }

    /**
     * 验证
     */
    @PostMapping("/verify")
    public void verify(@RequestBody JdRefundQualityCheckDto dto) {
        jdRefundQualityCheckService.verify(dto.getId());
    }

    /**
     * 批量验证
     */
    @PostMapping("/batchVerify")
    public void batchVerify(@RequestBody JdRefundQualityCheckDto dto) {
        jdRefundQualityCheckService.batchVerify(dto.getIds());
    }

    @GetMapping("/deptList")
    public List<SysDept> deptList() {
        DynamicDataSourceContextHolder.push(SourceConstant.BASE);

        try {
            return sysDeptService.lambdaQuery().like(SysDept::getParentId, "1650750129810030596").orderByAsc(SysDept::getOrderNum).list()
                    .stream().flatMap(item -> sysDeptService.lambdaQuery().like(SysDept::getParentId, item.getDeptId()).orderByAsc(SysDept::getOrderNum).list().stream())
                    .collect(Collectors.toList());
        } finally {
            DynamicDataSourceContextHolder.poll();
        }

    }


}
