package com.fjhx.victoriatourist.entity.jd.vo;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;

/**
 * 京东售后退货质检列表查询返回值实体
 *
 * @author
 * @since 2024-09-27
 */
@Getter
@Setter
public class JdRefundQualityCheckExcelVo {

    @ColumnWidth(15)
    @ExcelProperty("质检单号")
    private String code;

    @ColumnWidth(20)
    @ExcelProperty("物品编码")
    private String productCustomCode;

    @ColumnWidth(20)
    @ExcelProperty("物品名称")
    private String productName;

    @ColumnWidth(20)
    @ExcelProperty("规格")
    private String productSpec;

    @ColumnWidth(15)
    @ExcelProperty("单位")
    private String productUnit;

    @ColumnWidth(15)
    @ExcelProperty("报废数量")
    private String scrappedCount;

    @ColumnWidth(15)
    @ExcelProperty("报废转良品数量")
    private String scrappedToQualifiedCount;

    @ColumnWidth(15)
    @ExcelProperty("报废转次品数量")
    private String scrappedToDefectiveCount;

    @ColumnWidth(15)
    @ExcelProperty("最终报废数量")
    private String resultScrappedCount;

    @ColumnWidth(15)
    @ExcelProperty("状态")
    private String scrappedHandleStatus;

    @ColumnWidth(20)
    @ExcelProperty("生成时间")
    private Date scrappedHandleTime;

    @ColumnWidth(20)
    @ExcelProperty("验证时间")
    private Date scrappedVerifyTime;

    public void setScrappedHandleStatus(String scrappedHandleStatus) {
        switch (scrappedHandleStatus) {
            case "1":
                this.scrappedHandleStatus = "待处理";
                break;
            case "2":
                this.scrappedHandleStatus = "待验证";
                break;
            case "3":
                this.scrappedHandleStatus = "已验证";
                break;
            default:
                this.scrappedHandleStatus = "未知状态";
        }
    }

}
